SystemOrganization addCategory: #'tODE-Amber'!

WAComponent subclass: #TOAmberAbstractComponent
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object
	^ object! !

!TOAmberAbstractComponent methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:25'!
object: anObject
	object := anObject! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderContentOn: json
	self subclassResponsibility! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
renderJsonOn: aRenderer
	self renderWithContext: aRenderer context! !

!TOAmberAbstractComponent methodsFor: 'rendering' stamp: 'dkh 10/3/2011 22:25'!
rendererClass
	^ WAJsonCanvas! !

TOAmberAbstractComponent subclass: #TOAmberFrameComponent
	instanceVariableNames: 'expression target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberFrameComponent class methodsFor: 'accessing' stamp: 'dkh 10/25/2011 10:10'!
applicationPath

	^'tools/amber/frame'! !

!TOAmberFrameComponent class methodsFor: 'class initialization' stamp: 'dkh 10/25/2011 10:07'!
initialize
	"self initialize"

	self register! !

!TOAmberFrameComponent class methodsFor: 'class initialization' stamp: 'dkh 10/26/2011 19:39'!
register
    "self register"

    ^ (WAJsonAdmin register: self asApplicationAt: self applicationPath)
        preferenceAt: #sessionClass put: TOSeasideSession;
        exceptionHandler: TOAmberErrorHandler;
        yourself! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression

	^expression! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:39'!
expression: aString

	expression := aString! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/9/2011 09:45'!
notifier
	^ TOPharoCompilationRequestor new requestor: self! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/15/2011 10:15'!
object
	object ifNil: [ ^ object := TORoot current currentSession homeObject ].
	^ object! !

!TOAmberFrameComponent methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:06'!
renderContentOn: json
    | renderer |
    renderer := (TOAmberFrameRenderer new)
        frameComponent: self;
        object: self object;
        yourself.
    renderer renderContentOn: json! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:31'!
states

	^#()! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/25/2011 21:26'!
target
    "target is a one-shot variable:
     _self - object displayed in current session
     _blank - new session created to display the object"

    | ans |
    target ifNil: [ ^ '_self' ].
    ans := target.
    target := nil.
    ^ ans! !

!TOAmberFrameComponent methodsFor: 'accessing' stamp: 'dkh 10/26/2011 20:33'!
target: aByteString
    "  
       _self - object displayed in current session
       _blank - new session created to display the object"

    target := aByteString! !

WAComponent subclass: #TOAmberCounter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:15'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberCounter class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:17'!
description
	^ 'Amber & Seaside-JSON example counter'! !

!TOAmberCounter class methodsFor: 'class initialization' stamp: 'dkh 9/26/2011 21:22'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-counter'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application	"exception handler for TOMain is always TOSeasideErrorHandler"! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:33'!
renderContentOn: html
	html script url: '/Kaliningrad/js/amber.js'.
	html script with: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	html strong: 'Amber Counter:'.
	html break.
	html script with: 'smalltalk.TOASeasideCounter._open()'.
! !

!TOAmberCounter methodsFor: 'rendering' stamp: 'dkh 9/26/2011 21:47'!
updateRoot: aHtmlRoot

	super updateRoot: aHtmlRoot.
	aHtmlRoot title: 'Amber Counter'.
! !

WAComponent subclass: #TOAmberMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 9/25/2011 11:33'!
addLibraries: aToMainApplication

	aToMainApplication
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		addLibrary: TOJQueryLibrary;
		addLibrary: TOStyleSheet! !

!TOAmberMain class methodsFor: 'accessing' stamp: 'dkh 9/26/2011 21:08'!
description
	^ 'tODE Amber Main'! !

!TOAmberMain class methodsFor: 'class initialization' stamp: 'dkh 10/5/2011 17:32'!
initialize
	"self initialize"

	| application |
	(application := WAAdmin
		register: self
		asApplicationAt: 'tools/amber-tODE'
		user: 'admin'
		password: 'tool')
		preferenceAt: #sessionClass put: TOSeasideSession;
		exceptionHandler: TOSeasideErrorHandler.
	self addLibraries: application.
	KOAmberBrowser addAmberFile: 'tODEAmberClient.js'	"until tODE can be used to edit Amber code"! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/5/2011 17:52'!
renderContentOn: html
	html document addLoadScript: (html jQuery ajaxSetup onError: html javascript refresh).
	html script with: 'smalltalk.TOAMain._open()'! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 16:06'!
style
	^'
html {height:100%; overflow:hidden}
	body {
		overflow:auto;
		height:100%;
		margin:0;
		padding:0;
		font-size:11px;
		font-family:Verdana}
 	h1 {color:#ff7200;background:#ddd;margin:0;padding:4px;padding-bottom:0px}

		.ui-layout-content {
                        height: 100%;
                        width: 100%;
			overflow:		auto; /* add scrolling to content-divs (panel-wrappers) */

			border-top:		0 !!important; /* tab-buttons above this DIV already has a border-bottom */
		}


		.ui-tabs-nav li {

			white-space:	nowrap;

		}

		.ui-tabs-nav li a {

			font-size:		1em !!important;

			padding:		4px 1.5ex 3px !!important;

		}

		.ui-tabs-panel {

			font-size:		1em !!important;

			padding:		0 1em !!important;

		}


	.ui-layout-resizer {   
		background: #DDD; 
	}

 
	.ui-layout-toggler {  
		background: #AAA; 
	} 
	.ui-layout-toggler .content {
	   font-size: 12px; /* IMPORTANT: default = 1px */
	   font-weight: bold;
	   text-align: center}
	.ui-layout-toggler-north .content {   
		 font-size: 7px;
	} 

#north .ltab, #north .rtab, #north .mtab {
    height: 22px;
    float: left;
}

#north .ltab, #north .rtab {
    width: 8px;
}

#north .rtab {
    margin-right: 1px;
}

#north .mtab {
    line-height: 20px;
}

'
! !

!TOAmberMain methodsFor: 'rendering' stamp: 'dkh 10/15/2011 13:57'!
updateRoot: aHtmlRoot

	aHtmlRoot title: 'Amber tODE'.
	aHtmlRoot addScript: '$(document).ready(function () {
	$(''body'').layout({ 
north : {
   size : ''auto''
,  resizable : false
,  togglerLength_open : 20
,  togglerLength_closed : 20
,  togglerContent_closed : ''v''
,  togglerContent_open : ''^''
}
, south : {
   size : 120
}
});
})'.
	aHtmlRoot script url: '/Kaliningrad/js/amber.js'.
	aHtmlRoot addScript: 'loadAmber({
	   files: [''KaliningradCore.js'', ''tODEAmberClient.js'']
	 })'.
	super updateRoot: aHtmlRoot! !

WAWalkbackErrorHandler subclass: #TOAmberErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberErrorHandler class methodsFor: 'exception handling' stamp: 'dkh 10/9/2011 13:52'!
exceptionSelector
	^ super exceptionSelector, Halt! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleException: anException
	(Halt handles: anException)
		ifTrue: [ ^ self handleHalt: anException ].

	^ super handleException: anException! !

!TOAmberErrorHandler methodsFor: 'actions' stamp: 'dkh 10/9/2011 13:52'!
handleHalt: anError

	^ self handleDefault: anError! !

WAJsonComponent subclass: #TOJsonCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:06'!
initialize
	"self initialize"
	
	self register! !

!TOJsonCounter class methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:05'!
register
	(WAJsonAdmin register: self asApplicationAt: 'tools/json-counter')
		exceptionHandler: WAHtmlHaltAndErrorHandler.! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/24/2011 22:04'!
decrease
	count := count - 1! !

!TOJsonCounter methodsFor: 'actions' stamp: 'dkh 9/25/2011 10:22'!
increase
	count := count + 1! !

!TOJsonCounter methodsFor: 'initialization' stamp: 'dkh 9/24/2011 22:04'!
initialize
	super initialize.
	count := 0! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:10'!
renderActionsOn: json
	json
		key: 'increase' value: [ json callback: [ self increase ] ];
		key: 'decrease' value: [ json callback: [ self decrease ] ]! !

!TOJsonCounter methodsFor: 'as yet unclassified' stamp: 'dkh 9/27/2011 21:09'!
renderStateOn: json
	json key: 'count' value: count! !

!Object methodsFor: '*tode-amber' stamp: 'dkh 10/27/2011 10:11'!
tODEAmberMetaRendererClass
    ^ TOAmberMetaRenderer! !

!Object methodsFor: '*tode-amber' stamp: 'dkh 10/27/2011 10:04'!
tODEAmberViewRendererClass
    ^ TOAmberInspectorRenderer! !

Object subclass: #TOAmberAbstractRenderer
	instanceVariableNames: 'object frameComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberAbstractRenderer methodsFor: 'metacello' stamp: 'dkh 10/27/2011 15:54'!
configurationInfo
    | configurationInfo wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self packageClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ 
                            configurationInfo := config.
                            ^ config ] ] ].
    ^ configurationInfo! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/22/2011 11:02'!
frameComponent
    ^ frameComponent! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/22/2011 11:02'!
frameComponent: anObject
    frameComponent := anObject! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object
	^ object! !

!TOAmberAbstractRenderer methodsFor: 'accessing' stamp: 'dkh 10/3/2011 22:51'!
object: anObject
	object := anObject! !

!TOAmberAbstractRenderer methodsFor: 'metacello' stamp: 'dkh 10/27/2011 15:54'!
packageClass
    ^ self object class theNonMetaClass! !

!TOAmberAbstractRenderer methodsFor: 'metacello' stamp: 'dkh 10/27/2011 15:54'!
packageInfo
    | wc |
    MCWorkingCopy registry
        do: [ :mgr | 
            (mgr packageInfo includesClass: self packageClass)
                ifTrue: [ wc := mgr ] ].
    wc ifNil: [ ^ nil ].
    MBConfigurationRoot current configurations
        do: [ :config | 
            config packages
                do: [ :pkg | 
                    pkg basePackageName = wc packageName
                        ifTrue: [ ^ pkg ] ] ].
    ^ MBPackageInfo named: wc packageName! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 09:55'!
renderBlockMethod
    "[:frame :object :html :main | ...]"
! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/16/2011 18:01'!
renderBlockSource

	^self renderBlockMethod asString! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:05'!
renderContentOn: json
! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:15'!
renderSessionTitleOn: json
    self renderTitleOn: json! !

!TOAmberAbstractRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:15'!
renderTitleOn: json
    json render: self object tODETitle! !

!TOAmberAbstractRenderer methodsFor: 'callback support' stamp: 'dkh 10/27/2011 10:08'!
requestContext

	^self frameComponent requestContext! !

TOAmberAbstractRenderer subclass: #TOAmberFrameRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberFrameRenderer methodsFor: 'expression handling' stamp: 'dkh 10/27/2011 15:31'!
handleExpression: exp on: json
    | result |
    self frameComponent expression: nil.
    result := self viewRenderer evaluateExpression: exp.
    json
        object: [ 
            self renderMetaOn: json.
            self renderViewOn: json.
            json key: 'url' value: [ json callback: [ self frameComponent object: result ] ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 16:02'!
metaRenderer
    ^ (self object tODEAmberMetaRendererClass new)
        frameComponent: self frameComponent;
        frameRenderer: self;
        object: self object;
        yourself! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:59'!
renderContentOn: json
    self frameComponent expression ifNotNil: [ :exp | ^ self handleExpression: exp on: json ].
    json
        object: [ 
            self renderMetaOn: json.
            self renderViewOn: json.
            json
                key: 'url'
                value: [ 
                    | o |
                    o := self frameComponent object.
                    json
                        callback: [ 
                            self requestContext request url queryFields at: 'expression' ifPresent: [ :exp | self frameComponent expression: exp ].
                            self frameComponent object: o ] ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 14:42'!
renderMetaOn: json
    | renderer |
    renderer := self metaRenderer.
    json key: 'metaTitle' value: [ renderer renderTitleOn: json ].
    json
        key: 'meta'
        value: [ 
            json
                object: [ 
                    json key: 'state' value: [ renderer renderContentOn: json ].
                    json key: 'renderBlockSource' value: renderer renderBlockSource ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 14:42'!
renderViewOn: json
    | renderer |
    renderer := self viewRenderer.
    json key: 'viewTitle' value: [ renderer renderTitleOn: json ].
    json key: 'target' value: self frameComponent target.
    json key: 'sessionTitle' value: [ renderer renderSessionTitleOn: json ].
    json
        key: 'view'
        value: [ 
            json
                object: [ 
                    json key: 'state' value: [ renderer renderContentOn: json ].
                    json key: 'renderBlockSource' value: renderer renderBlockSource ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 14:42'!
viewRenderer
    ^ (self object tODEAmberViewRendererClass new)
        frameComponent: self frameComponent;
        object: self object;
        yourself! !

TOAmberAbstractRenderer subclass: #TOAmberMetaRenderer
	instanceVariableNames: 'configRenderer frameRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberMetaRenderer methodsFor: 'accessing' stamp: 'dkh 10/27/2011 16:01'!
frameRenderer
    ^ frameRenderer! !

!TOAmberMetaRenderer methodsFor: 'accessing' stamp: 'dkh 10/27/2011 16:01'!
frameRenderer: aFrameRenderer
    frameRenderer := aFrameRenderer! !

!TOAmberMetaRenderer methodsFor: 'metacello' stamp: 'dkh 10/27/2011 16:02'!
packageClass
    ^ self frameRenderer viewRenderer packageClass! !

!TOAmberMetaRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:59'!
renderBlockMethod
    ^configRenderer renderBlockMethod! !

!TOAmberMetaRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:58'!
renderContentOn: json
    json
        object: [ 
            json
                key: 'configuration'
                value: [ 
                    configRenderer := self configurationInfo
                        ifNil: [ 
                            (TOAmberCreateConfigurationRenderer new)
                                frameComponent: self frameComponent;
                                object: nil;
                                yourself ]
                        ifNotNil: [ :config | 
                            (TOAmberConfigurationRenderer new)
                                frameComponent: self frameComponent;
                                object: config;
                                yourself ].
                    configRenderer renderContentOn: json ] ]! !

!TOAmberMetaRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 10:28'!
renderTitleOn: json
    | strm |
    strm := WriteStream on: String new.
    self configurationInfo ifNil: [ strm nextPutAll: '--' ] ifNotNil: [ :config | strm nextPutAll: config printString ].
    strm nextPutAll: ' : '.
    self packageInfo ifNil: [ strm nextPutAll: '--' ] ifNotNil: [ :pkg | strm nextPutAll: pkg printString ].
    json render: strm contents! !

TOAmberAbstractRenderer subclass: #TOAmberViewRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

TOAmberViewRenderer subclass: #TOAmberConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberConfigurationRenderer methodsFor: 'actions' stamp: 'dkh 10/25/2011 10:24'!
createConfiguration: configName inRepository: repoName
self error: 'Create configuration: ' , configName , ' in: ' , repoName.
    Transcript
        cr;
        show: 'Create configuration: ' , configName , ' in: ' , repoName! !

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 15:46'!
renderBlockMethod
    ^ [ :frame :obj :html :main | 
    html with: 'Configuration'.
    html ul
        with: [ 
            | configName repoName |
            (html button)
                onClick: [  ];
                with: 'Project changes'.
            html br.
            (html button)
                onClick: [  ];
                with: 'Save project' ].
    html with: 'Package'.
    html ul
        with: [ 
            | configName repoName |
            (html button)
                onClick: [  ];
                with: 'Package changes'.
            html br.
            (html button)
                onClick: [  ];
                with: 'Save package' ] ]! !

!TOAmberConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 15:50'!
renderContentOn: json
    json
        object: [ json key: 'repositories' value: [ json array: [ self repositories do: [ :repo | json value: repo description ] ] ] ]! !

!TOAmberConfigurationRenderer methodsFor: 'accessing' stamp: 'dkh 10/16/2011 19:31'!
repositories
	^ (MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ])
		sorted: [ :a :b | a description <= b description ]! !

TOAmberConfigurationRenderer subclass: #TOAmberCreateConfigurationRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:18'!
renderBlockMethod
    ^ [ :frame :obj :html :main | 
    | configName repoName |
    (html button)
        onClick: [ 
                    | url |
                    url := obj configuration createConfigurationURL , '&configName='
                        , (frame encodeURIComponent: configName asJQuery val) , '&repoName='
                        , (frame encodeURIComponent: repoName asJQuery val).
                    frame
                        getRequest: url
                        main: main
                        do: [ :jsonObject | 
                            frame session push: jsonObject url.
                            main renderCenter ] ];
        with: 'Create configuration'.
    configName := html inputWithExampleText: 'Configuration name'.
    repoName := html select with: [ obj configuration repositories do: [ :repository | html option with: repository ] ] ]! !

!TOAmberCreateConfigurationRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 11:40'!
renderContentOn: json 
    ^ json
        object: [ 
            json key: 'repositories' value: [ json array: [ self repositories do: [ :repo | json value: repo description ] ] ].
            json
                key: 'createConfigurationURL'
                value: [ 
                    json
                        callback: [ 
                            | fc repoName configName |
                            fc := self frameComponent.
                            fc requestContext request url queryFields
                                at: 'repoName'
                                ifPresent: [ :val | repoName := val ].
                            fc requestContext request url queryFields
                                at: 'configName'
                                ifPresent: [ :val | configName := val ].
                            self createConfiguration: configName inRepository: repoName.
                            fc object: 'SUCCESS!!' ] ] ]! !

TOAmberViewRenderer subclass: #TOAmberInspectorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Amber'!

!TOAmberInspectorRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 08:57'!
members
    ^ TORoot current currentSession currentSystem
        inspectorField: #tODEBasicInspectorFields
        from: self object class
        to: nil
        for: self object! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:19'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    html table
        with: [ 
            obj members
                do: [ :member | 
                    html tr
                        with: [ 
                            | td |
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | key url |
                                    key := member key.
                                    (url := key at: 2) isNil
                                        ifTrue: [ html with: (key at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (key at: 1) ] ].
                            td := html td.
                            td style: 'padding: .3px 4px;'.
                            td
                                with: [ 
                                    | value url |
                                    value := member value.
                                    (url := value at: 2) isNil
                                        ifTrue: [ html with: (value at: 1) ]
                                        ifFalse: [ 
                                            (html a)
                                                href: '#';
                                                onClick: [ 
                                                            frame session push: url.
                                                            main renderCenter ];
                                                with: (value at: 1) ] ] ] ] ] ]! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:36'!
renderContentOn: json
    json object: [ self renderMembersOn: json ]! !

!TOAmberInspectorRenderer methodsFor: 'rendering' stamp: 'dkh 10/27/2011 11:36'!
renderMembersOn: json
    | members |
    members := self members.
    json
        key: 'members'
        value: [ 
            json
                array: [ 
                    members
                        do: [ :fieldSpec | 
                            json
                                value: [ 
                                    json
                                        object: [ 
                                            json
                                                key: 'key'
                                                value: [ 
                                                    json
                                                        array: [ 
                                                            json value: fieldSpec keyLabel.
                                                            fieldSpec hasKey
                                                                ifTrue: [ 
                                                                    json
                                                                        value: [ 
                                                                            json
                                                                                callback: [ 
                                                                                    (self frameComponent)
                                                                                        target: fieldSpec target;
                                                                                        object: fieldSpec key ] ] ]
                                                                ifFalse: [ json value: nil ] ] ].
                                            json
                                                key: 'value'
                                                value: [ 
                                                    json
                                                        array: [ 
                                                            json value: fieldSpec valueLabel.
                                                            fieldSpec hasValue
                                                                ifTrue: [ 
                                                                    json
                                                                        value: [ 
                                                                            json
                                                                                callback: [ 
                                                                                    (self frameComponent)
                                                                                        target: fieldSpec target;
                                                                                        object: fieldSpec value ] ] ]
                                                                ifFalse: [ json value: nil ] ] ] ] ] ] ] ]! !

!TOAmberViewRenderer methodsFor: 'expression handling' stamp: 'dkh 10/27/2011 14:48'!
evaluateExpression: exp
    ^ TORoot current currentSession currentSystem
        evaluate: exp
        in: nil
        to: self object
        notifying: self notifier
        ifFail: [ self error: 'evaluation failed' ]! !

!TOAmberViewRenderer methodsFor: 'expression handling' stamp: 'dkh 10/27/2011 14:49'!
notifier

	^self frameComponent notifier! !
TOAmberFrameComponent initialize!
TOAmberCounter initialize!
TOAmberMain initialize!
TOJsonCounter initialize!
